//
//  SelectorEnum.swift
//  TapThemeManager2020
//
//  Created by Osama Rabie on 09/03/2020.
//  Copyright © 2020 Osama Rabie. All rights reserved.
//

/// Typealiases for the performed selectors for easier and unified access
internal class SelectorsConstants {
    static let setAlphaSelector = "setAlpha:"
    static let setBackgroundColorSelector = "setBackgroundColor:"
    static let setTintColorSelector = "setTintColor:"
    static let setStatusBarStyleAnimatedSelector = "setStatusBarStyle:animated:"
    static let setImageSelector = "setImage:"
    static let setTitleTextAttributesForStateSelector = "setTitleTextAttributes:forState:"
    static let setFontSelector = "setFont:"
    static let setTextColorSelector = "setTextColor:"
    static let setHighlightedTextColorSelector = "setHighlightedTextColor:"
    static let setShadowColorSelector = "setShadowColor:"
    static let tap_setTextAttributesSelector = "tap_setTextAttributes:"
    static let setBarStyleSelector = "setBarStyle:"
    static let setBarTintColorSelector = "setBarTintColor:"
    static let setTitleTextAttributesSelector = "setTitleTextAttributes:"
    static let setLargeTitleTextAttributesSelector = "setLargeTitleTextAttributes:"
    @available(iOS 13.0, *)
    static let setStandardAppearanceSelector = "setStandardAppearance:"
    @available(iOS 13.0, *)
    static let setCompactAppearanceSelector = "setCompactAppearance:"
    @available(iOS 13.0, *)
    static let setScrollEdgeAppearanceSelector = "setScrollEdgeAppearance:"
    static let setUnselectedItemTintColorSelector = "setUnselectedItemTintColor:"
    static let setSelectedImageSelector = "setSelectedImage:"
    static let setSeparatorColorSelector = "setSeparatorColor:"
    static let setSectionIndexColorSelector = "setSectionIndexColor:"
    static let setSectionIndexBackgroundColorSelector = "setSectionIndexBackgroundColor:"
    static let setKeyboardAppearanceSelector = "setKeyboardAppearance:"
    static let tap_setPlaceholderAttributesSelector = "tap_setPlaceholderAttributes:"
    static let setProgressTintColorSelector = "setProgressTintColor:"
    static let setTrackTintColorSelector = "setTrackTintColor:"
    static let setPageIndicatorTintColorSelector = "setPageIndicatorTintColor:"
    static let setCurrentPageIndicatorTintColorSelector = "setCurrentPageIndicatorTintColor:"
    static let setColorSelector = "setColor:"
    static let setActivityIndicatorViewStyleSelector = "setActivityIndicatorViewStyle:"
    static let setIndicatorStyleSelector = "setIndicatorStyle:"
    static let setImageforStateSelector = "setImage:forState:"
    static let setBackgroundImageforStateSelector = "setBackgroundImage:forState:"
    static let setTitleColorforStateSelector = "setTitleColor:forState:"
    static let setShadowImageSelector = "setShadowImage:"
    static let setBackgroundEffectSelector = "setBackgroundEffect:"
    static let setBackgroundImageSelector = "setBackgroundImage:"
    static let setBackIndicatorImageSelector = "setBackIndicatorImage:"
    static let setEffectSelector = "setEffect:"
    static let tap_setTitleAttributesSelector = "tap_setTitleAttributes:"
    static let setMaximumTrackTintColorSelector = "setMaximumTrackTintColor:"
    static let setMinimumTrackTintColorSelector = "setMinimumTrackTintColor:"
    static let setThumbTintColorSelector = "setThumbTintColor:"
    static let setOnTintColorSelector = "setOnTintColor:"
    static let setSelectedSegmentTintColorSelector = "setSelectedSegmentTintColor:"
    static let setBorderWidthSelector = "setBorderWidth:"
    static let setBorderColorSelector = "setBorderColor:"
    static let setStrokeColorSelector = "setStrokeColor:"
    static let setFillColorSelector = "setFillColor:"
    static let setCornerRadiusSelector = "setCornerRadius:"
    
}
